> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/api-reference/more-products-apis/service-reliability-management/healthsources.md).

# Healthsources

This contains APIs related to CV Health Sources

## GET /health-sources

> List Health Sources

```json
{"openapi":"3.0.1","info":{"title":"SRM Service API Reference","version":"3.0"},"tags":[{"name":"Healthsources","description":"This contains APIs related to CV Health Sources"}],"servers":[{"url":"https://cv-nextgen-94fb8b655-lbzqs"}],"paths":{"/health-sources":{"get":{"tags":["Healthsources"],"summary":"List Health Sources","operationId":"listHealthSources","parameters":[{"name":"accountIdentifier","in":"query","description":"Account Identifier","required":true,"schema":{"type":"string"}},{"name":"orgIdentifier","in":"query","description":"Organization Identifier","schema":{"type":"string"}},{"name":"projectIdentifier","in":"query","description":"Project Identifier","schema":{"type":"string"}}],"responses":{"default":{"description":"Lists all Health Sources for the given scope","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseDTOListHealthSourceResponse"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/ResponseDTOListHealthSourceResponse"}}}}}}}},"components":{"schemas":{"ResponseDTOListHealthSourceResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","FAILURE","ERROR"]},"data":{"type":"array","items":{"$ref":"#/components/schemas/HealthSourceResponse"}},"metaData":{"type":"object"},"correlationId":{"type":"string"}}},"HealthSourceResponse":{"type":"object","properties":{"accountId":{"type":"string","description":"Account identifier"},"orgIdentifier":{"type":"string","description":"Organization identifier"},"projectIdentifier":{"type":"string","description":"Project identifier"},"identifier":{"type":"string","description":"Identifier of the Health Source"},"name":{"type":"string","description":"Name of the Health Source"},"connectorRef":{"type":"string","description":"Connector reference for the data source"},"mcpRef":{"type":"string","description":"MCP reference for AI/ML capabilities"},"dataSourceType":{"type":"string","description":"Type of data source","enum":["DatadogMetrics","DynatraceGrailLogs","DynatraceGrailMetrics","PrometheusMetrics","CustomLogs","AgentCoreTrace","SplunkLogs","CustomMetrics","NewRelicMetrics","AppDynamicsMetrics","CloudWatchMetrics","CloudWatchLogs","StackdriverMetrics","StackdriverLogs","AzureLogLogs","DatadogLogs","SumologicLogs","ElasticSearchLogs","GrafanaLokiLogs"]},"queryDefinitions":{"$ref":"#/components/schemas/QueryDefinitionsWrapper"},"healthSourceParams":{"type":"object","additionalProperties":{"type":"string","description":"Additional parameters for the health source"},"description":"Additional parameters for the health source"},"variables":{"type":"array","description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","items":{"$ref":"#/components/schemas/NGVariable"}},"createdAt":{"type":"integer","description":"Creation timestamp","format":"int64"},"lastUpdatedAt":{"type":"integer","description":"Last updated timestamp","format":"int64"}},"description":"Response containing Health Source details"},"QueryDefinitionsWrapper":{"required":["spec","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of verification - METRICS, LOGS, or TRACES","enum":["Metrics","Logs","Traces"]},"spec":{"$ref":"#/components/schemas/QueryDefinitionsDTO"}},"description":"Wrapper for query definitions containing type and spec"},"QueryDefinitionsDTO":{"required":["type"],"type":"object","properties":{"type":{"type":"string"}},"description":"Query definitions specification","discriminator":{"propertyName":"type"}},"NGVariable":{"type":"object","properties":{"name":{"type":"string"},"type":{"type":"string","enum":["String","Number","Secret"]},"required":{"type":"boolean"},"description":{"type":"string"},"metadata":{"type":"string"}},"description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","discriminator":{"propertyName":"type"}}}}}
```

## POST /health-sources

> Create a Health Source

```json
{"openapi":"3.0.1","info":{"title":"SRM Service API Reference","version":"3.0"},"tags":[{"name":"Healthsources","description":"This contains APIs related to CV Health Sources"}],"servers":[{"url":"https://cv-nextgen-94fb8b655-lbzqs"}],"paths":{"/health-sources":{"post":{"tags":["Healthsources"],"summary":"Create a Health Source","operationId":"createHealthSource","parameters":[{"name":"accountIdentifier","in":"query","description":"Account Identifier","required":true,"schema":{"type":"string"}},{"name":"orgIdentifier","in":"query","description":"Organization Identifier","schema":{"type":"string"}},{"name":"projectIdentifier","in":"query","description":"Project Identifier","schema":{"type":"string"}}],"requestBody":{"description":"Health Source configuration","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HealthSource"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/HealthSource"}}},"required":true},"responses":{"default":{"description":"Creates a new Health Source for verifying metrics or logs","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseDTOHealthSourceResponse"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/ResponseDTOHealthSourceResponse"}}}}}}}},"components":{"schemas":{"HealthSource":{"required":["connectorRef","dataSourceType","identifier","name","queryDefinitions"],"type":"object","properties":{"identifier":{"type":"string","description":"Identifier of the Health Source"},"name":{"type":"string","description":"Name of the Health Source"},"connectorRef":{"type":"string","description":"Connector reference for the data source"},"mcpRef":{"type":"string","description":"MCP reference for AI/ML capabilities"},"dataSourceType":{"type":"string","description":"Type of data source","enum":["DatadogMetrics","DynatraceGrailLogs","DynatraceGrailMetrics","PrometheusMetrics","CustomLogs","AgentCoreTrace","SplunkLogs","CustomMetrics","NewRelicMetrics","AppDynamicsMetrics","CloudWatchMetrics","CloudWatchLogs","StackdriverMetrics","StackdriverLogs","AzureLogLogs","DatadogLogs","SumologicLogs","ElasticSearchLogs","GrafanaLokiLogs"]},"queryDefinitions":{"$ref":"#/components/schemas/QueryDefinitionsWrapper"},"healthSourceParams":{"type":"object","additionalProperties":{"type":"string","description":"Additional parameters for the health source"},"description":"Additional parameters for the health source"},"variables":{"type":"array","description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","items":{"$ref":"#/components/schemas/NGVariable"}}},"description":"This contains details of the Health Source configuration"},"QueryDefinitionsWrapper":{"required":["spec","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of verification - METRICS, LOGS, or TRACES","enum":["Metrics","Logs","Traces"]},"spec":{"$ref":"#/components/schemas/QueryDefinitionsDTO"}},"description":"Wrapper for query definitions containing type and spec"},"QueryDefinitionsDTO":{"required":["type"],"type":"object","properties":{"type":{"type":"string"}},"description":"Query definitions specification","discriminator":{"propertyName":"type"}},"NGVariable":{"type":"object","properties":{"name":{"type":"string"},"type":{"type":"string","enum":["String","Number","Secret"]},"required":{"type":"boolean"},"description":{"type":"string"},"metadata":{"type":"string"}},"description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","discriminator":{"propertyName":"type"}},"ResponseDTOHealthSourceResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","FAILURE","ERROR"]},"data":{"$ref":"#/components/schemas/HealthSourceResponse"},"metaData":{"type":"object"},"correlationId":{"type":"string"}}},"HealthSourceResponse":{"type":"object","properties":{"accountId":{"type":"string","description":"Account identifier"},"orgIdentifier":{"type":"string","description":"Organization identifier"},"projectIdentifier":{"type":"string","description":"Project identifier"},"identifier":{"type":"string","description":"Identifier of the Health Source"},"name":{"type":"string","description":"Name of the Health Source"},"connectorRef":{"type":"string","description":"Connector reference for the data source"},"mcpRef":{"type":"string","description":"MCP reference for AI/ML capabilities"},"dataSourceType":{"type":"string","description":"Type of data source","enum":["DatadogMetrics","DynatraceGrailLogs","DynatraceGrailMetrics","PrometheusMetrics","CustomLogs","AgentCoreTrace","SplunkLogs","CustomMetrics","NewRelicMetrics","AppDynamicsMetrics","CloudWatchMetrics","CloudWatchLogs","StackdriverMetrics","StackdriverLogs","AzureLogLogs","DatadogLogs","SumologicLogs","ElasticSearchLogs","GrafanaLokiLogs"]},"queryDefinitions":{"$ref":"#/components/schemas/QueryDefinitionsWrapper"},"healthSourceParams":{"type":"object","additionalProperties":{"type":"string","description":"Additional parameters for the health source"},"description":"Additional parameters for the health source"},"variables":{"type":"array","description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","items":{"$ref":"#/components/schemas/NGVariable"}},"createdAt":{"type":"integer","description":"Creation timestamp","format":"int64"},"lastUpdatedAt":{"type":"integer","description":"Last updated timestamp","format":"int64"}},"description":"Response containing Health Source details"}}}}
```

## PUT /health-sources

> Update a Health Source

```json
{"openapi":"3.0.1","info":{"title":"SRM Service API Reference","version":"3.0"},"tags":[{"name":"Healthsources","description":"This contains APIs related to CV Health Sources"}],"servers":[{"url":"https://cv-nextgen-94fb8b655-lbzqs"}],"paths":{"/health-sources":{"put":{"tags":["Healthsources"],"summary":"Update a Health Source","operationId":"updateHealthSource","parameters":[{"name":"accountIdentifier","in":"query","description":"Account Identifier","required":true,"schema":{"type":"string"}},{"name":"orgIdentifier","in":"query","description":"Organization Identifier","schema":{"type":"string"}},{"name":"projectIdentifier","in":"query","description":"Project Identifier","schema":{"type":"string"}}],"requestBody":{"description":"Health Source configuration","content":{"application/json":{"schema":{"$ref":"#/components/schemas/HealthSource"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/HealthSource"}}},"required":true},"responses":{"default":{"description":"Updates an existing Health Source configuration","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseDTOHealthSourceResponse"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/ResponseDTOHealthSourceResponse"}}}}}}}},"components":{"schemas":{"HealthSource":{"required":["connectorRef","dataSourceType","identifier","name","queryDefinitions"],"type":"object","properties":{"identifier":{"type":"string","description":"Identifier of the Health Source"},"name":{"type":"string","description":"Name of the Health Source"},"connectorRef":{"type":"string","description":"Connector reference for the data source"},"mcpRef":{"type":"string","description":"MCP reference for AI/ML capabilities"},"dataSourceType":{"type":"string","description":"Type of data source","enum":["DatadogMetrics","DynatraceGrailLogs","DynatraceGrailMetrics","PrometheusMetrics","CustomLogs","AgentCoreTrace","SplunkLogs","CustomMetrics","NewRelicMetrics","AppDynamicsMetrics","CloudWatchMetrics","CloudWatchLogs","StackdriverMetrics","StackdriverLogs","AzureLogLogs","DatadogLogs","SumologicLogs","ElasticSearchLogs","GrafanaLokiLogs"]},"queryDefinitions":{"$ref":"#/components/schemas/QueryDefinitionsWrapper"},"healthSourceParams":{"type":"object","additionalProperties":{"type":"string","description":"Additional parameters for the health source"},"description":"Additional parameters for the health source"},"variables":{"type":"array","description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","items":{"$ref":"#/components/schemas/NGVariable"}}},"description":"This contains details of the Health Source configuration"},"QueryDefinitionsWrapper":{"required":["spec","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of verification - METRICS, LOGS, or TRACES","enum":["Metrics","Logs","Traces"]},"spec":{"$ref":"#/components/schemas/QueryDefinitionsDTO"}},"description":"Wrapper for query definitions containing type and spec"},"QueryDefinitionsDTO":{"required":["type"],"type":"object","properties":{"type":{"type":"string"}},"description":"Query definitions specification","discriminator":{"propertyName":"type"}},"NGVariable":{"type":"object","properties":{"name":{"type":"string"},"type":{"type":"string","enum":["String","Number","Secret"]},"required":{"type":"boolean"},"description":{"type":"string"},"metadata":{"type":"string"}},"description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","discriminator":{"propertyName":"type"}},"ResponseDTOHealthSourceResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","FAILURE","ERROR"]},"data":{"$ref":"#/components/schemas/HealthSourceResponse"},"metaData":{"type":"object"},"correlationId":{"type":"string"}}},"HealthSourceResponse":{"type":"object","properties":{"accountId":{"type":"string","description":"Account identifier"},"orgIdentifier":{"type":"string","description":"Organization identifier"},"projectIdentifier":{"type":"string","description":"Project identifier"},"identifier":{"type":"string","description":"Identifier of the Health Source"},"name":{"type":"string","description":"Name of the Health Source"},"connectorRef":{"type":"string","description":"Connector reference for the data source"},"mcpRef":{"type":"string","description":"MCP reference for AI/ML capabilities"},"dataSourceType":{"type":"string","description":"Type of data source","enum":["DatadogMetrics","DynatraceGrailLogs","DynatraceGrailMetrics","PrometheusMetrics","CustomLogs","AgentCoreTrace","SplunkLogs","CustomMetrics","NewRelicMetrics","AppDynamicsMetrics","CloudWatchMetrics","CloudWatchLogs","StackdriverMetrics","StackdriverLogs","AzureLogLogs","DatadogLogs","SumologicLogs","ElasticSearchLogs","GrafanaLokiLogs"]},"queryDefinitions":{"$ref":"#/components/schemas/QueryDefinitionsWrapper"},"healthSourceParams":{"type":"object","additionalProperties":{"type":"string","description":"Additional parameters for the health source"},"description":"Additional parameters for the health source"},"variables":{"type":"array","description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","items":{"$ref":"#/components/schemas/NGVariable"}},"createdAt":{"type":"integer","description":"Creation timestamp","format":"int64"},"lastUpdatedAt":{"type":"integer","description":"Last updated timestamp","format":"int64"}},"description":"Response containing Health Source details"}}}}
```

## GET /health-sources/{identifier}

> Get a Health Source

```json
{"openapi":"3.0.1","info":{"title":"SRM Service API Reference","version":"3.0"},"tags":[{"name":"Healthsources","description":"This contains APIs related to CV Health Sources"}],"servers":[{"url":"https://cv-nextgen-94fb8b655-lbzqs"}],"paths":{"/health-sources/{identifier}":{"get":{"tags":["Healthsources"],"summary":"Get a Health Source","operationId":"getHealthSource","parameters":[{"name":"accountIdentifier","in":"query","description":"Account Identifier","required":true,"schema":{"type":"string"}},{"name":"orgIdentifier","in":"query","description":"Organization Identifier","schema":{"type":"string"}},{"name":"projectIdentifier","in":"query","description":"Project Identifier","schema":{"type":"string"}},{"name":"identifier","in":"path","description":"Health Source Identifier","required":true,"schema":{"type":"string"}}],"responses":{"default":{"description":"Retrieves a Health Source by its identifier","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseDTOOptionalHealthSourceResponse"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/ResponseDTOOptionalHealthSourceResponse"}}}}}}}},"components":{"schemas":{"ResponseDTOOptionalHealthSourceResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","FAILURE","ERROR"]},"data":{"$ref":"#/components/schemas/HealthSourceResponse"},"metaData":{"type":"object"},"correlationId":{"type":"string"}}},"HealthSourceResponse":{"type":"object","properties":{"accountId":{"type":"string","description":"Account identifier"},"orgIdentifier":{"type":"string","description":"Organization identifier"},"projectIdentifier":{"type":"string","description":"Project identifier"},"identifier":{"type":"string","description":"Identifier of the Health Source"},"name":{"type":"string","description":"Name of the Health Source"},"connectorRef":{"type":"string","description":"Connector reference for the data source"},"mcpRef":{"type":"string","description":"MCP reference for AI/ML capabilities"},"dataSourceType":{"type":"string","description":"Type of data source","enum":["DatadogMetrics","DynatraceGrailLogs","DynatraceGrailMetrics","PrometheusMetrics","CustomLogs","AgentCoreTrace","SplunkLogs","CustomMetrics","NewRelicMetrics","AppDynamicsMetrics","CloudWatchMetrics","CloudWatchLogs","StackdriverMetrics","StackdriverLogs","AzureLogLogs","DatadogLogs","SumologicLogs","ElasticSearchLogs","GrafanaLokiLogs"]},"queryDefinitions":{"$ref":"#/components/schemas/QueryDefinitionsWrapper"},"healthSourceParams":{"type":"object","additionalProperties":{"type":"string","description":"Additional parameters for the health source"},"description":"Additional parameters for the health source"},"variables":{"type":"array","description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","items":{"$ref":"#/components/schemas/NGVariable"}},"createdAt":{"type":"integer","description":"Creation timestamp","format":"int64"},"lastUpdatedAt":{"type":"integer","description":"Last updated timestamp","format":"int64"}},"description":"Response containing Health Source details"},"QueryDefinitionsWrapper":{"required":["spec","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of verification - METRICS, LOGS, or TRACES","enum":["Metrics","Logs","Traces"]},"spec":{"$ref":"#/components/schemas/QueryDefinitionsDTO"}},"description":"Wrapper for query definitions containing type and spec"},"QueryDefinitionsDTO":{"required":["type"],"type":"object","properties":{"type":{"type":"string"}},"description":"Query definitions specification","discriminator":{"propertyName":"type"}},"NGVariable":{"type":"object","properties":{"name":{"type":"string"},"type":{"type":"string","enum":["String","Number","Secret"]},"required":{"type":"boolean"},"description":{"type":"string"},"metadata":{"type":"string"}},"description":"Variables that can be substituted into queries using <+healthSourceVariables.name>","discriminator":{"propertyName":"type"}}}}}
```

## DELETE /health-sources/{identifier}

> Delete a Health Source

```json
{"openapi":"3.0.1","info":{"title":"SRM Service API Reference","version":"3.0"},"tags":[{"name":"Healthsources","description":"This contains APIs related to CV Health Sources"}],"servers":[{"url":"https://cv-nextgen-94fb8b655-lbzqs"}],"paths":{"/health-sources/{identifier}":{"delete":{"tags":["Healthsources"],"summary":"Delete a Health Source","operationId":"deleteHealthSource","parameters":[{"name":"accountIdentifier","in":"query","description":"Account Identifier","required":true,"schema":{"type":"string"}},{"name":"orgIdentifier","in":"query","description":"Organization Identifier","schema":{"type":"string"}},{"name":"projectIdentifier","in":"query","description":"Project Identifier","schema":{"type":"string"}},{"name":"identifier","in":"path","description":"Health Source Identifier","required":true,"schema":{"type":"string"}}],"responses":{"default":{"description":"Deletes a Health Source by its identifier","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseDTOBoolean"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/ResponseDTOBoolean"}}}}}}}},"components":{"schemas":{"ResponseDTOBoolean":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","FAILURE","ERROR"]},"data":{"type":"boolean"},"metaData":{"type":"object"},"correlationId":{"type":"string"}}}}}}
```

## GET /health-sources/{identifier}/runtime-inputs

> Get runtime inputs for a Health Source

```json
{"openapi":"3.0.1","info":{"title":"SRM Service API Reference","version":"3.0"},"tags":[{"name":"Healthsources","description":"This contains APIs related to CV Health Sources"}],"servers":[{"url":"https://cv-nextgen-94fb8b655-lbzqs"}],"paths":{"/health-sources/{identifier}/runtime-inputs":{"get":{"tags":["Healthsources"],"summary":"Get runtime inputs for a Health Source","operationId":"getHealthSourceRuntimeInputs","parameters":[{"name":"accountIdentifier","in":"query","description":"Account Identifier","required":true,"schema":{"type":"string"}},{"name":"orgIdentifier","in":"query","description":"Organization Identifier","schema":{"type":"string"}},{"name":"projectIdentifier","in":"query","description":"Project Identifier","schema":{"type":"string"}},{"name":"identifier","in":"path","description":"Health Source Identifier","required":true,"schema":{"type":"string"}}],"responses":{"default":{"description":"Returns only the fields marked as <+input> on the saved HealthSource. Embed runtimeInputYaml directly as healthSourceInputs in the AI Verify step YAML.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseDTOHealthSourceRuntimeInputs"}},"application/yaml":{"schema":{"$ref":"#/components/schemas/ResponseDTOHealthSourceRuntimeInputs"}}}}}}}},"components":{"schemas":{"ResponseDTOHealthSourceRuntimeInputs":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","FAILURE","ERROR"]},"data":{"$ref":"#/components/schemas/HealthSourceRuntimeInputs"},"metaData":{"type":"object"},"correlationId":{"type":"string"}}},"HealthSourceRuntimeInputs":{"type":"object","properties":{"hasRuntimeInputs":{"type":"boolean","description":"True when the HealthSource has at least one <+input> field"},"runtimeInputYaml":{"type":"string","description":"YAML snippet to embed directly as healthSourceInputs: in the AI Verify step YAML. Null when hasRuntimeInputs is false."},"runtimeInputs":{"$ref":"#/components/schemas/JsonNode"}},"description":"Fields on the HealthSource that require runtime input values (<+input> marked). Embed runtimeInputYaml directly as healthSourceInputs in the AI Verify step."},"JsonNode":{"type":"object","description":"Same data in JSON form for typed UI rendering. Null when hasRuntimeInputs is false."}}}}
```
